
Taazza.Media = {
	absPath: function(relPath) {
		return Taazza.Conf.RES_DIR + relPath;
	},

	BASE_URL: 'http://s.taazza.com/media/',

	Icon: {
		// Title Bar
		MARKER        : 'media/icons/marker.png',

		// Main Window
		AROUND        : 'media/icons/globe.png',
		NEWS          : ['media/icons/166-newspaper.png', 'media/icons/gray-166-newspaper.png'],
		PLACES        : ['media/icons/nearby.png', 'media/icons/gray-nearby.png'],
		DEALS         : ['media/icons/24-gift.png', 'media/icons/gray-24-gift.png'],
		EVENTS        : ['media/icons/83-calendar.png', 'media/icons/gray-83-calendar.png'],
		CITIZEN       : ['media/icons/112-group.png', 'media/icons/gray-112-group.png'],
		TIP           : 'media/icons/tip.png',
		ISSUE         : 'media/icons/sad.png',

		// Option Menu
		SETTINGS      : 'ic_menu_preferences.png',
		ABOUT         : 'ic_menu_info_details.png',
		FEEDBACK      : 'ic_menu_start_conversation.png',
		MAPVIEW       : 'ic_menu_mapmode.png',
		REFRESH       : 'ic_menu_refresh.png',
		SHAREAPP      : 'ic_menu_share.png',
		SHARE         : 'ic_act_allfriends.png',
		SAVE          : 'ic_act_save.png',
		TERMS         : 'ic_menu_agenda.png',
		CALL          : 'ic_menu_call.png',
		DIRECTIONS    : 'ic_menu_directions.png',

		// List Window
		DEAL          : 'media/icons/shopping.png',
		EVENT         : 'media/icons/movie.png',
		DEFAULT_PLACE : 'media/icons/globe.png',         // OPTIMIZE: Same as Icon.AROUND
		DIALOG_MORE   : 'ic_dialog_menu_generic_24.png',

		// Detail Window

		// Settings Window
		SET_REFRESH  : 'media/icons/01-refresh.png',
		SET_OFFLINE  : 'media/icons/96-book.png',
		SET_LOC      : 'media/icons/74-location.png',
		SET_EXIT     : 'media/icons/63-runner.png',
		SET_LANG     : 'media/icons/45-movie1.png',
		SOCIAL       : 'media/icons/black-112-group.png',
		SET_TWITTER  : 'media/icons/23-bird.png',
		INSTAPAPER   : 'media/icons/instapaper.png',
		SET_RESET    : 'media/icons/106-sliders.png',
		USER         : 'media/icons/111-user.png',
		PASSWORD     : 'media/icons/30-key.png',
		SHOW_MORE    : 'ic_menu_more.png',

		// Locate Window
		LOCATION      : 'ic_menu_mylocation.png',
		LOCATE        : 'media/icons/btn_locate.png',
		LOCATION_SAVE : 'media/icons/btn_check_on.png',
		BLACK_MARKER  : 'media/icons/07-map-marker.png',
		SEARCHING     : 'media/icons/ic_btn_search.png',
		SEARCH        : 'media/icons/btn_search.png',

		// Report Window
		CAMERA        : 'media/icons/86-camera.png',

		// Citizen Detail
		THUMBS_UP     : 'media/icons/dark_thumb-up.png',
		THUMBS_DOWN   : 'media/icons/dark_thumb-down.png',
		COMMENT       : 'media/icons/dark_comment.png',
		FLAG          : 'media/icons/dark_flag.png',

		// Source: http://github.com/appcelerator/titanium_mobile/tree/master/android/modules/facebook/src/ti/modules/titanium/facebook/resources/
		FB            : 'media/icons/fbicon.png',
		TWITTER       : 'media/icons/twitter.png',

		OVERVIEW      : ['media/icons/gray-12-eye.png', 'media/icons/12-eye.png'],
		DETAILS       : ['media/icons/gray-117-todo.png', 'media/icons/117-todo.png'],
		OUTLET        : ['media/icons/gray-113-navigation.png', 'media/icons/113-navigation.png'],
		REVIEWS       : ['media/icons/gray-124-bullhorn.png', 'media/icons/124-bullhorn.png']
	},

	Marker: {
		ORANGE : 'media/images/orange-pin.png',
		RED    : 'media/images/red-pin.png',
		GREEN  : 'media/images/green-pin.png',
		PURPLE : 'media/images/purple-pin.png',
		BLUE   : 'media/images/blue-pin.png'
	},

	Image: {
		HEADER      : 'media/images/bilinear.png',
		LOADING     : 'spinner_black_76.png',
		DETAIL      : 'media/images/chevron.png',
		BACK        : 'media/images/lchevron.png',
		LOGO        : 'media/images/logo.png',
		QRCODE      : 'media/images/qrcode.png',
		NOWEATHER   : 'media/images/noweather.png',

		for_weather : function(img_id) {
			if (img_id) {
				return this.BASE_URL + 'weather/' + img_id + '.png';
			} else {
				return this.NOWEATHER;
			}
		},

		// REFACTOR: This is duplicate code
		for_deal: function(src) {
			return Taazza.Media.Icon.BASE_URL + 'deals/' + src.toLowerCase() + '.png';
		},

		for_source: function(src) {
			return Taazza.Media.Icon.BASE_URL + 'sources/' + src.toLowerCase() + '.png';
		},

		for_tool: function(src) {
			return this.BASE_URL + 'tools/' + src.toLowerCase() + '.png';
		},

		for_event: function(src) {
			return Taazza.Media.Icon.BASE_URL + 'events/' + src.toLowerCase() + '.png';
		}
	}
};

(function() {
	var c, i, k, v, keys = ['Icon', 'Marker', 'Image'];
	for (i = 0; i < keys.length; ++i) {
		c = Taazza.Media[keys[i]];
		for (k in c) {
			if (c.hasOwnProperty(k)) {
				v = c[k];
				switch (typeof v)
				{
				case 'string':
					c[k] = Taazza.Media.absPath(v);
					break;

				case 'object':
					for (var j = 0; j < v.length; ++j) {
						v[j] = Taazza.Media.absPath(v[j]);
					}
					break;
				}
			}
		}
	}

	Taazza.Media.Icon.BASE_URL  = Taazza.Media.BASE_URL + 'icons/';
	Taazza.Media.Image.BASE_URL = Taazza.Media.BASE_URL + 'images/';
})();

