// TODO: REFACTOR: Rajat: needs to be split into utilities, config & UI

var Taazza;

if (Taazza == null) {
	Taazza = {
		// Tabs
		News: {},
		City: {},

		Deal: {},

		Event: {},

		PlaceCategory: {},
		Place: {},

		CitizenCategory: {},
		Citizen: {},

		Media: {},

		Ctrller: {},

		Conf: {
			TZ_OFFSET: (new Date().getTimezoneOffset()) * 60,
			MONTH_NAMES: ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"],

			GREEN: "#96C03E",
			RES_DIR: (Ti.Platform.osname == 'android' ? Ti.Filesystem.resourcesDirectory : '/') // TODO: Move into platform.js
		},

		Util: {
			include: function() {
				for (var i = 0; i < arguments.length; ++i) {
					Ti.include(Taazza.Conf.RES_DIR + arguments[i]);
				}
			},

			copyProperties: function(src, dst, keys) {
				var k;
				if (keys) {
					var l = keys.length;
					for (var i = 0; i < l; ++i) {
						k = keys[i];
						if (src[k]) {
							dst[k] = src[k];
						}
					}
				} else {
					for (k in src) {
					//	BUG: Commented out check because it breaks in MapWindow
					//	if (src.hasOwnProperty(k)) {
							dst[k] = src[k];
					//	}
					}
				}
			},

			// creates a 'pretty date' from a unix time stamp
			// obtained from http://phpjs.org/functions/strtotime:554
			prettyDate: function(time, expiry) {
				var date, diff;
				if (expiry) {
					date = new Date(time);
					diff = ((date.getTime()-(new Date()).getTime()) / 1000);
				} else {
					date = new Date((time - Taazza.Conf.TZ_OFFSET) * 1000);
					diff = (((new Date()).getTime() - date.getTime()) / 1000);
				}
				var day_diff = Math.floor(diff / 86400);
				if ( isNaN(day_diff) || day_diff < 0 ) {
					return '';
				}
				if (day_diff >= 31) {
					var date_year = date.getFullYear();
					var month_name = Taazza.Conf.MONTH_NAMES[date.getMonth()];
					var date_month = date.getMonth() + 1;
					if (date_month < 10) {
						date_month = "0" + date_month;
					}
					var date_monthday = date.getDate();
					if (date_monthday < 10) {
						date_monthday = "0" + date_monthday;
					}				
					return (expiry ? 'on ' : '') + date_monthday + " " + month_name + " " + date_year;
				}
				if (expiry) {
					return day_diff == 0 && (
						diff < 60 && "in a few seconds" ||
						diff < 120 && "in 1 minute" ||
						diff < 3600 && "in " + Math.floor( diff / 60 ) + " minutes" ||
						diff < 7200 && "in 1 hour" ||
						diff < 86400 && "in about " + Math.floor( diff / 3600 ) + " hours") ||
					day_diff == 1 && "in a day" ||
					day_diff < 7 && "in " + day_diff + " days" ||
					day_diff < 31 && "in " + Math.ceil( day_diff / 7 ) + " week" + ((Math.ceil( day_diff / 7 )) == 1 ? "" : "s");
				} else {
					return day_diff == 0 && (
						diff < 60 && "just now" ||
						diff < 120 && "1 minute ago" ||
						diff < 3600 && Math.floor( diff / 60 ) + " minutes ago" ||
						diff < 7200 && "1 hour ago" ||
						diff < 86400 && "about " + Math.floor( diff / 3600 ) + " hours ago") ||
					day_diff == 1 && "Yesterday" ||
					day_diff < 7 && day_diff + " days ago" ||
					day_diff < 31 && Math.ceil( day_diff / 7 ) + " week" + ((Math.ceil( day_diff / 7 )) == 1 ? "" : "s") + " ago";
				}
			},

			safeCall: function(f, context) {
				return function(args) {
					try {
						if (context) {
							f.call(context, args);
						} else {
							f(args);
						}
					} catch(exception) {
						Taazza.notifyException(exception);
					}
				};
			},

			safeListener: function(src, evt, listener) {
				src.addEventListener(evt, Taazza.Util.safeCall(listener, src));
			},

			prunedAddress: function(addr) {
				var c = addr.split(',');
				c = c.splice(c.length-(c.length > 2 ? 3 : c.length));
				var title = c[0].replace(/^\s+/, '');
				// Max size of 20 (17 + 3 for ellipsis)
				if (title.length > 17) {
					title = title.substr(0, 17) + "...";
				}

				return [title, c.splice(1).join(',').replace(/^\s+/, '')];
			}
		}
	};

	Taazza.Util.include('lib/media.js',
			    'lib/status.js',
			    'lib/apiclient.js');

	var tix = new TixClient();

	Taazza.getTitleBar = function(title, icon) {
		var titleView = Ti.UI.createView({
			top: 0,
			backgroundColor: '#EEE',
			height: 42,
			zIndex: 5,
			borderColor: '#AAA',
			borderWidth: 1
		});

		titleView.add(Ti.UI.createImageView({
			image: Taazza.Media.Image.LOGO,
			left: 10,
			width: 'auto',
			height: 'auto'
		}));
		var titleLoc = Ti.UI.createLabel({
			text: title ? title : Ti.App.Properties.getString('address'),
			right: 30,
			width: 150,
			height: 38,
			color: '#666',
			textAlign: 'right',
			font: {fontSize: title ? 12 : 10}
		});
		titleView.add(titleLoc);
		titleView.add(Ti.UI.createImageView({
			image: icon ? icon : Taazza.Media.Icon.MARKER,
			right: 10,
			width: 'auto',
			height: 'auto'
		}));

		return titleView;
	};

	// REFACTOR: We don't care about title on Android because we always
	// hide the title bar. On iPhone this might be necessary.
	Taazza.openWindow = function(opts) {
		var winOptions = {
		    title: (opts.title ? opts.title : 'Default'), // i18n
		    backgroundColor: '#FFF',
		    animate: true,
		    width: 0,
		    fullscreen: false,
		    navBarHidden: true,
		    'Taazza': Taazza,
		    'Status': Status,
		    'APIClient': APIClient,
		    'TixClient': TixClient,
		};
		if (opts.url) {
			winOptions.url = Taazza.Conf.RES_DIR + opts.url;
		}

		if (opts.data) {
			Taazza.Util.copyProperties(opts.data, winOptions);
		}

		var win = Ti.UI.createWindow(winOptions);

		var views = opts.views;
		if (views && views instanceof Array) {
			for (var i = 0; i < views.length; ++i) {
				win.add(views[i]);
			}
		}
		var listeners = opts.listeners;
		if (listeners) {
			for (var k in listeners) {
				if (listeners.hasOwnProperty(k)) {
					win.addEventListener(k, listeners[k]);
				}
			}
		}
		win.open(Ti.UI.createAnimation({
		    fullscreen: false,
		    navBarHidden: true,
		    width: Ti.Platform.displayCaps.platformWidth,
		    duration: 1000
		}));
	};

	Taazza.getChildTitle = function(opts) {
		var fTitleView = Ti.UI.createView({
			top: 0,
			left: 0,
			right: 0,
			height: 30,
			backgroundColor: '#000',
			opacity: 0.7
		});
		if (opts) {
			if (opts.layout) {
				fTitleView.layout = opts.layout;
			}
			if (opts.prevTitle) {
				fTitleView.add(Ti.UI.createImageView({
					image: Taazza.Media.Image.BACK,
					left: 3,
					width: 'auto',
					height: 'auto'
				}));
				fTitleView.add(Ti.UI.createLabel({
					left: 5,
					title: opts.prevTitle,
					color: '#EEE',
					font: {fontFamily: 'Verdana',
					       fontSize: 11}
				}));
			}
			if (opts.title) {
				var labelOpts = {height: 20,
						 top: 5,
						 bottom: 5,
						 text: opts.title,
						 textAlign: 'center',
						 color: opts.color ? opts.color : '#EEE',
						 font: {fontFamily: 'Helvetica Neue',
					       		fontSize: opts.size ? opts.size : 14,
					       		fontWeight: opts.weight ? opts.weight : 'bold'},
						 ellipsize: true};
				if (opts.ellipsize) {
					labelOpts.left = 5;
//					labelOpts.width = 150;
					labelOpts.right = 5;
				}
				var label = Ti.UI.createLabel(labelOpts);
				fTitleView.add(label);
				fTitleView.heading = label;
			}
		}

		return fTitleView;
	};

	Taazza.openChildWindow = function(opts) {
		var context = opts.context;
		var fwin = Ti.UI.createWindow({
			top: 115,
			backgroundColor: '#FFF',
			zIndex: 1,
			// TODO: _TI_BUG_:Using layout: 'vertical' on window makes tableview rows disappear!
			// Workaround for a possible Titanium bug.
			// See http://developer.appcelerator.com/question/23431/mobile-simple-group-tableview-not-showing-up-help
			headerHeight: 30
		});
		fTitleView = Taazza.getChildTitle({title: opts.currentTitle,
						   prevTitle: opts.prevTitle,
						   ellipsize: opts.ellipsize,
						   layout: 'horizontal'});
		fTitleView.addEventListener('click', function(e) {
			fwin.close();
			context.win.show();
			context.win.visible = true;
		});
		fwin.add(fTitleView);
		opts.action(fwin);

		fwin.open();
		context.win.hide();
		context.win.visible = false;
	};

	/* 
	 *	Browser
	 */
	var tbrowser = Ti.UI.createWebView({loading: true, top: 42, scalesPageToFit: true});
	tbrowser.addEventListener('beforeload', function(e) {
		this.visible = false;
		Status.show(L('SM_LOAD'));
	});
	tbrowser.addEventListener('load', function(e) {
		this.visible = true;
	});
	tbrowser.addEventListener('error', function(e) {
		this.visible = true;
		Status.show(L('SM_OPENFAILED'), true);
	});

	Taazza.Browser = {view: tbrowser};
	Taazza.Browser.open = function(url, title, bar_title, bar_icon) {
		// NOTE: Hide the view if we are loading a new URL
		// and show it after we are done loading it.
		if (url != this.view.url) {
			this.view.visible = false;
			this.view.url = url;
		}
		Taazza.openWindow({title: title,
				   views: [Taazza.getTitleBar(bar_title, bar_icon),
					   this.view]});
		// NOTE: Show status only if we are loading a new URL
		if (!this.view.visible) {
			Status.show(url.indexOf('html/') == 0 ? L('SM_LOAD') : L('SM_OPENPAGE'));
		}
	};

	Taazza.Google = {};

	Taazza.Google.getDrivingDirections = function(src, dst) {
		return "http://maps.google.com/maps?f=d&saddr=" + src.lat + "," + src.lon + "&daddr=" + dst.lat + "," + dst.lon + "&hl=en";
	};

	Taazza.Google.getStaticMap = function(lat, lon, w, h, zoom) {
		if (!zoom) {
			zoom = 13;
		}

		return 'http://maps.google.com/maps/api/staticmap?markers=' + lat + ',' + lon + '&size=' + w + 'x' + h + '&sensor=false&format=jpg&zoom=' + zoom;
	};

	Taazza.REPORT_URL = 'http://spreadsheets.google.com/a/taazza.com/embeddedform?formkey=dDhqY2tRcTNtbF80d0xGS2RyTjJDMEE6MQ';
	Taazza.SUGGEST_URL = 'http://spreadsheets.google.com/embeddedform?formkey=dEJNLURRU0VSX0tlTExmdlFhLTRPakE6MQ';

	Taazza.shareInfo = function(s) {
		Ti.API.info(s);
		var dialog = Ti.UI.createOptionDialog({
			title: L('DT_SHARE'),
			options: ['Facebook', 'Twitter', 'Email', 'SMS'],
			cancel: -1
		});
		dialog.addEventListener('click', function(e) {
			var share_opts = {'via': this.options[e.index],
					  'item_type': s.type,
					  'item_id': s.id};
			// NOTE: Track only if an option is chosen
			if (e.index >= 0 && e.index < this.options.length) {
				tix.track('share_item', share_opts);
			}
			switch (e.index)
			{
			case 0:
			case 1:
				Taazza.openWindow({url: String.format('ui/%sWindow.js', (e.index == 0 ? 'Facebook' : 'Twitter')),
						   title: 'Authorize', // i18n
						   data: {result: s}});
				break;

			case 2:
				var sub = '', msg = '';
				switch (s.type)
				{
				case 'deal':
					sub = String.format(L('PT_SHARE_EMAIL_SUB_DEAL'), s.type);
					msg = String.format(L('PT_SHARE_EMAIL_MSG_DEAL'), 'a deal/coupon', s.title);
					break;

				case 'event':
					sub = String.format(L('PT_SHARE_EMAIL_SUB_DEAL'), s.type);
					msg = String.format(L('PT_SHARE_EMAIL_MSG_DEAL'), 'an event', s.title);
					break;

				case 'citizen':
					sub = String.format(L('PT_SHARE_EMAIL_SUB'), s.title.substr(0,80));
					msg = String.format(L('PT_SHARE_EMAIL_MSG_CITIZEN'));
					break;

				default:
					sub = String.format(L('PT_SHARE_EMAIL_SUB'), s.title.substr(0,80));
					msg = L('PT_SHARE_EMAIL_MSG_NEWS');
					break;
				}
				Ti.UI.createEmailDialog({
					subject: sub,
					messageBody: String.format(L('PT_SHARE_EMAIL_MSG'), msg, s.url)
				}).open();
				break;

			case 3:
				// TODO: Insert proper locale-based messages
				var sub = '', msg = '';
				switch (s.type)
				{
				case 'deal':
					sub = "Taazza Deal";
					msg = s.url;
					break;

				case 'event':
					sub = "Taazza Event: I'm watching";
					msg = " at " + s.url;
					break;

				case 'citizen':
					sub = "Taazza Citizen: I reported an issue";
					msg = " at " + s.url;
					break;

				case 'news':
					sub = "Taazza News";
					msg = s.url;
					break;

				case 'app':
					sub = "Hot & Useful";
					msg = s.url;
					break;

				default:
					// TODO: HOPTOAD: Throw an exception, shouldnt come in here
					Ti.API.debug('Unsupported Option');
					break;
				}

				Taazza.Platform.sendSMS(sub + ": " + s.title + " - " + msg);
				break;

			default:
				// Likely that the back button was used to close the dialog. Do nothing.
				Ti.API.debug('Unsupported Option');
				break;
			}
		});
		dialog.show();
	};
}


String.prototype.capitalize = function() {
   return this.replace( /(^|\s)([a-z])/g , function(m,p1,p2) { return p1+p2.toUpperCase(); } );
};
